AttachersSetStateEvent = {};
AttachersSetStateEvent_mt = Class(AttachersSetStateEvent, Event);

InitEventClass(AttachersSetStateEvent, "AttachersSetStateEvent")

function AttachersSetStateEvent:emptyNew()
    local self = Event:new(AttachersSetStateEvent_mt);
    return self;
end;

function AttachersSetStateEvent:new(object, foldAttachers)
    local self = AttachersSetStateEvent:emptyNew()
    self.object = object;
    self.foldAttachers = foldAttachers;
    return self;
end;

function AttachersSetStateEvent:readStream(streamId, connection)
    self.object = readNetworkNodeObject(streamId);
    self.foldAttachers = streamReadBool(streamId);
    self:run(connection);
end;

function AttachersSetStateEvent:writeStream(streamId, connection)
    writeNetworkNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.foldAttachers);
end;

function AttachersSetStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:setAttachersState(self.foldAttachers, true);
    end;
end;

function AttachersSetStateEvent.sendEvent(vehicle, foldAttachers, noEventSend)
    if foldAttachers ~= vehicle.foldAttachers then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(AttachersSetStateEvent:new(vehicle, foldAttachers), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(AttachersSetStateEvent:new(vehicle, foldAttachers));
            end;
        end;
    end;
end;
