WheelsSetStateEvent = {};
WheelsSetStateEvent_mt = Class(WheelsSetStateEvent, Event);

InitEventClass(WheelsSetStateEvent, "WheelsSetStateEvent")

function WheelsSetStateEvent:emptyNew()
    local self = Event:new(WheelsSetStateEvent_mt);
    return self;
end;

function WheelsSetStateEvent:new(object, foldWheels)
    local self = WheelsSetStateEvent:emptyNew()
    self.object = object;
    self.foldWheels = foldWheels;
    return self;
end;

function WheelsSetStateEvent:readStream(streamId, connection)
    self.object = readNetworkNodeObject(streamId);
    self.foldWheels = streamReadBool(streamId);
    self:run(connection);
end;

function WheelsSetStateEvent:writeStream(streamId, connection)
    writeNetworkNodeObject(streamId, self.object);
    streamWriteBool(streamId, self.foldWheels);
end;

function WheelsSetStateEvent:run(connection)
    if not connection:getIsServer() then
        g_server:broadcastEvent(self, false, connection, self.object);
    end;
    if self.object ~= nil then
        self.object:setWheelsState(self.foldWheels, true);
    end;
end;

function WheelsSetStateEvent.sendEvent(vehicle, foldWheels, noEventSend)
    if foldWheels ~= vehicle.foldWheels then
        if noEventSend == nil or noEventSend == false then
            if g_server ~= nil then
                g_server:broadcastEvent(WheelsSetStateEvent:new(vehicle, foldWheels), nil, nil, vehicle);
            else
                g_client:getServerConnection():sendEvent(WheelsSetStateEvent:new(vehicle, foldWheels));
            end;
        end;
    end;
end;
